# Generated by Django 4.2 on 2024-05-15 20:38

import django.contrib.gis.db.models.fields
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='AppCategory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200)),
                ('order', models.IntegerField(default=0)),
                ('priority', models.IntegerField(default=0)),
            ],
            options={
                'ordering': ['priority'],
            },
        ),
        migrations.CreateModel(
            name='GeoContext',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=200, unique=True)),
                ('description', models.TextField(blank=True, default='')),
                ('regions_overpass_query', models.TextField(blank=True, default='')),
                ('regions_name_tag', models.CharField(blank=True, default='name', max_length=200)),
                ('provinces_overpass_query', models.TextField(blank=True, default='')),
                ('provinces_name_tag', models.CharField(blank=True, default='name', max_length=200)),
                ('municipalities_overpass_query', models.TextField(blank=True, default='')),
                ('municipalities_name_tag', models.CharField(blank=True, default='name', max_length=200)),
            ],
        ),
        migrations.CreateModel(
            name='Query',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=200)),
                ('sparql', models.TextField()),
                ('description', models.TextField(blank=True, default='')),
                ('app_categories', models.ManyToManyField(blank=True, to='main.appcategory')),
                ('geo_context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='sparql_queries', to='main.geocontext')),
            ],
        ),
        migrations.CreateModel(
            name='Snapshot',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('complete', models.BooleanField(default=False)),
                ('csv_export', models.FileField(blank=True, null=True, upload_to='csv_exports')),
                ('xlsx_export', models.FileField(blank=True, null=True, upload_to='xlsx_exports')),
                ('geo_context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='snapshots', to='main.geocontext')),
            ],
        ),
        migrations.CreateModel(
            name='Region',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200)),
                ('code', models.CharField(max_length=200)),
                ('poly', django.contrib.gis.db.models.fields.MultiPolygonField(blank=True, null=True, srid=4326)),
                ('centroid', django.contrib.gis.db.models.fields.PointField(blank=True, null=True, srid=4326)),
                ('geo_context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='regions', to='main.geocontext')),
            ],
            options={
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='QuerySnapshot',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('payload', models.JSONField(default=None, editable=False, null=True)),
                ('complete', models.BooleanField(default=False)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('query', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='query_snapshots', to='main.query')),
                ('snapshot', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='query_snapshots', to='main.snapshot')),
            ],
        ),
        migrations.CreateModel(
            name='Province',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200)),
                ('code', models.CharField(max_length=200)),
                ('poly', django.contrib.gis.db.models.fields.MultiPolygonField(blank=True, null=True, srid=4326)),
                ('centroid', django.contrib.gis.db.models.fields.PointField(blank=True, null=True, srid=4326)),
                ('geo_context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='provinces', to='main.geocontext')),
                ('region', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='provinces', to='main.region')),
            ],
            options={
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='Municipality',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200)),
                ('code', models.CharField(max_length=200)),
                ('poly', django.contrib.gis.db.models.fields.MultiPolygonField(blank=True, null=True, srid=4326)),
                ('centroid', django.contrib.gis.db.models.fields.PointField(blank=True, null=True, srid=4326)),
                ('geo_context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='municipalities', to='main.geocontext')),
                ('province', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='municipalities', to='main.province')),
                ('region', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='municipalities', to='main.region')),
            ],
            options={
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='Monument',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.TextField()),
                ('q_number', models.CharField(max_length=200, unique=True)),
                ('parent_q_number', models.CharField(blank=True, default='', max_length=200)),
                ('wlm_n', models.CharField(blank=True, default='', max_length=200)),
                ('start', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('end', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('data', models.JSONField(default=dict)),
                ('position', django.contrib.gis.db.models.fields.PointField(blank=True, null=True, srid=4326)),
                ('relevant_images', models.JSONField(blank=True, default=list)),
                ('first_revision', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('approved_by', models.CharField(blank=True, default='', max_length=200)),
                ('first_image_date', models.DateField(blank=True, db_index=True, null=True)),
                ('first_image_date_commons', models.DateField(blank=True, db_index=True, null=True)),
                ('most_recent_wlm_image_date', models.DateField(blank=True, null=True)),
                ('most_recent_commons_image_date', models.DateField(blank=True, null=True)),
                ('current_wlm_state', models.CharField(blank=True, default='', max_length=20)),
                ('current_commons_state', models.CharField(blank=True, default='', max_length=20)),
                ('pictures_count', models.IntegerField(blank=True, default=0)),
                ('pictures_wlm_count', models.IntegerField(blank=True, default=0)),
                ('pictures_commons_count', models.IntegerField(blank=True, default=0)),
                ('to_review', models.BooleanField(default=False)),
                ('in_contest', models.BooleanField(default=False)),
                ('article', models.CharField(blank=True, default='', max_length=500)),
                ('location', models.CharField(blank=True, default='', max_length=500)),
                ('address', models.CharField(blank=True, default='', max_length=500)),
                ('admin_entity', models.CharField(blank=True, default='', max_length=100)),
                ('app_categories', models.ManyToManyField(blank=True, to='main.appcategory')),
                ('geo_context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='monuments', to='main.geocontext')),
                ('municipality', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='monuments', to='main.municipality')),
                ('province', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='monuments', to='main.province')),
                ('region', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='monuments', to='main.region')),
                ('snapshot', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='monuments', to='main.snapshot')),
                ('update_snapshot', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='update_monuments', to='main.snapshot')),
            ],
            options={
                'ordering': ['label'],
                'index_together': {('start', 'first_revision'), ('start', 'first_revision', 'first_image_date')},
            },
        ),
        migrations.CreateModel(
            name='Contest',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=200)),
                ('label_en', models.CharField(blank=True, default='', max_length=200)),
                ('start_date', models.DateField()),
                ('end_date', models.DateField()),
                ('description', models.TextField(blank=True, default='')),
                ('link', models.URLField(blank=True, default='', max_length=2000)),
                ('geo_context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='contests', to='main.geocontext')),
            ],
        ),
        migrations.AddField(
            model_name='appcategory',
            name='geo_context',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='app_categories', to='main.geocontext'),
        ),
        migrations.CreateModel(
            name='Picture',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image_id', models.CharField(max_length=200, unique=True)),
                ('image_url', models.URLField(max_length=2000)),
                ('image_date', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('image_title', models.TextField(blank=True, default='')),
                ('image_type', models.CharField(db_index=True, max_length=20)),
                ('data', models.JSONField(default=dict)),
                ('is_relevant', models.BooleanField(default=False)),
                ('monument', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='pictures', to='main.monument')),
            ],
            options={
                'index_together': {('monument', 'image_date')},
            },
        ),
        migrations.CreateModel(
            name='MonumentImage',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image_id', models.CharField(max_length=200, unique=True)),
                ('image_url', models.ImageField(upload_to='images')),
                ('image_date', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('image_title', models.TextField(blank=True, default='')),
                ('image_type', models.CharField(db_index=True, max_length=20)),
                ('data', models.JSONField(default=dict)),
                ('monument', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='images', to='main.monument')),
            ],
            options={
                'index_together': {('monument', 'image_date')},
            },
        ),
    ]
